// Generated by CoffeeScript 2.0.2
(function() {
  var async, cat, collect, compact, empty, first, intersection, project, where,
    indexOf = [].indexOf;

  ({async, collect, where, empty, cat, compact, intersection, first, project} = require("fairmont"));

  module.exports = function(config, acm) {
    var apex, apexGet, apexScan, containsApex, containsWild, fetch, get, hasBoth, list, match, multiScan, needsApex, regularlyQualify, root, scan, wild, wildGet, wildScan;
    // TODO: Consider how to handle multiple region cert placement.
    ({root, regularlyQualify} = require("../url")(config));
    wild = function(name) {
      return regularlyQualify("*." + root(name));
    };
    apex = function(name) {
      return regularlyQualify(root(name));
    };
    needsApex = function() {
      var ref;
      return ref = config.aws.domain, indexOf.call(config.aws.hostnames, ref) >= 0;
    };
    list = async(function*(current = [], token) {
      var CertificateSummaryList, NextToken, params;
      params = {
        CertificateStatuses: ["ISSUED"]
      };
      if (token) {
        params.NextToken = token;
      }
      ({CertificateSummaryList, NextToken} = (yield acm.listCertificates(params)));
      current = cat(current, CertificateSummaryList);
      if (NextToken) {
        return (yield list(current, NextToken));
      } else {
        return current;
      }
    });
    // Looks through many certs looking for a given domain as the primary.
    get = function(name, list) {
      return collect(where({
        DomainName: name
      }, list));
    };
    wildGet = function(name, list) {
      return get(wild(name), list);
    };
    apexGet = function(name, list) {
      return get(apex(name), list);
    };
    // Looks within an individual cert for its coverage of a given domain.
    scan = async(function*(name, CertificateArn) {
      var Certificate, alternates;
      ({Certificate} = (yield acm.describeCertificate({CertificateArn})));
      alternates = Certificate.SubjectAlternativeNames;
      if (indexOf.call(alternates, name) >= 0) {
        return CertificateArn;
      } else {
        return void 0;
      }
    });
    multiScan = async(function*(name, list) {
      var arns, cert;
      arns = (yield* (function*() {
        var j, len, results;
        results = [];
        for (j = 0, len = list.length; j < len; j++) {
          cert = list[j];
          results.push((yield scan(name, cert.CertificateArn)));
        }
        return results;
      })());
      return collect(compact(arns));
    });
    wildScan = async(function*(name, list) {
      return (yield multiScan(wild(name), list));
    });
    apexScan = async(function*(name, list) {
      return (yield multiScan(apex(name), list));
    });
    containsWild = async(function*(name, list) {
      var certs, wildArns;
      wildArns = collect(project("CertificateArn", wildGet(name, list)));
      certs = apexGet(name, list);
      return cat(wildArns, (yield wildScan(name, certs)));
    });
    containsApex = async(function*(name, list) {
      var apexArns, certs;
      apexArns = collect(project("CertificateArn", apexGet(name, list)));
      certs = wildGet(name, list);
      return cat(apexArns, (yield apexScan(name, certs)));
    });
    hasBoth = async(function*(name, list) {
      var a, i, w;
      a = (yield containsApex(name, list));
      w = (yield containsWild(name, list));
      i = intersection(a, w);
      if (empty(i)) {
        return false;
      } else {
        return first(i);
      }
    });
    match = async(function*(name, list) {
      var certs;
      if (needsApex()) {
        return (yield hasBoth(name, list));
      } else {
        certs = (yield containsWild(name, list));
        if (empty(certs)) {
          return false;
        } else {
          return first(certs);
        }
      }
    });
    fetch = async(function*(name) {
      var arn;
      if (arn = (yield match(name, (yield list())))) {
        return arn;
      } else {
        throw new Error("Unable to find the required certs in ACM.");
      }
    });
    return {fetch};
  };

}).call(this);
